/*
-*- coding: utf-8 -*-
gs.maxMonoConfigRouter v0.020
Copyright (c) 2010, TJ Usiyan a.k.a. griotspeak
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:
    * Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in the
      documentation and/or other materials provided with the distribution.
    * Neither the name of the MaxConfig nor the
      names of its contributors may be used to endorse or promote products
     derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY TJ USIYAN ``AS IS'' AND ANY
EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL TJ USIYAN BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. */

autowatch = 1;

inlets = 2;
outlets = 3;


var channelsMade = false;

var debugLevel;
//declareattribute("debugLevel",    null,            "setDebugLevel",            1);
setDebugLevel(1);

//debugLevel[1] = true;
//debugLevel[2] = true;
//debugLevel[3] = true;
//debugLevel[4] = true;
//debugLevel[5] = true;
//debugLevel[6] = true;

// 0 - silence
// 1 - function name at start
// 2 - function end
// 3 - variables at end of function
// 4 - variables at start of function
// 5 - lists. so many lists.
// 6 - setters and getters

function setDebugLevel(level) {
    if (level > 0) { post("                                --setDebugLevel--\n"); }
    debugLevel = new Array();
     for (var c = 0; c < 6; c++) {
        if (c <= level) {
            debugLevel[c] = true;
        }
        else {
            debugLevel[c] = false;
        }
    }
}

mcGlobal = new Global("maxMonoConfigGlobal");
mcGlobal.appList = new Array();
mcGlobal.toRouter = incomingMessages;
mcGlobal.newClient = processNewClientNotification;
mcGlobal.removeClient = removeClient;
mcGlobal.led = processLed;
mcGlobal.appWindow = updateWindowDimensions;

function incomingMessages() {
    if (debugLevel[1]) { post("                     ---incomingMessages-\n"); }
}

function processNewClientNotification(_appName, _key1, _key2, _width, _height, _displayColumnOffset, _displayRowOffset) {
    if (debugLevel > 0) { post("                                --processNewClientNotification--\n"); }
	
    //UPDATED
    if (debugLevel[5]) {
		post("appName:", _appName, "key1:", _key1, "key2:", _key2, "\n");
    	post("width:", _width, "height:", _height, "displayColumnOffset:", _displayColumnOffset, "displayRowOffset:", _displayRowOffset, "\n");
	}
    
    // 0<name> 1<channelObject> 2<channelNumber> 3<key1> 4<key2> 5<width>, 6<heigth>, 7<displayColumnOffset>, 8<displayRowOffset> 
    var appEntry = [_appName, "unassigned", "unassigned", _key1, _key2, _width, _height, 
    _displayColumnOffset, _displayRowOffset]; // !!All elements
    
    //first check for name of app
    if (!mcGlobal.appList.some(doesShareName, _appName)) {
        // set channelNumber and add app to list.
        // mcGlobal.appList is an array of arrays
        appEntry[2] = 0; // !!channel number
        mcGlobal.appList.push(appEntry);
    }
    else {
        if (debugLevel[5]) { post("in else\n"); }
        var counter = 0;
        var listLength = mcGlobal.appList.length;
        if (debugLevel[4]) { post("listLength:", listLength, "\n"); }
        var channelNumbersUsed = new Array();
        
        //count and check for same app
        for (;counter < listLength; counter++) {
            if (mcGlobal.appList[counter][0] == _appName) { // !!app Name
                //check if keys 
                if ((mcGlobal.appList[counter][3] == _key1) && (mcGlobal.appList[counter][4] == _key2)) { // !!key1
                    if (debugLevel[3]) { post(_appName, _key1, _key2, "seems to be present already\n"); }
                    return;
                }
                else {
                    // no need to count apps explicitly. channelNumbersUsed.length = the number of apps.
                    channelNumbersUsed.push(mcGlobal.appList[counter][2]); // !!Channel Number
                }
            }
        }
        
        counter = 0; 
        
        while (appEntry[2] == "unassigned") { // !!channel number
            if (channelNumbersUsed.indexOf(counter) < 0) {
                appEntry[2] = counter; // !!channel number
                mcGlobal.appList.push(appEntry);
            }
            else {
                counter++;
            }
        }
    }
    mcGlobal.appList.forEach(acknowledgeClient);
    if (debugLevel[5]) { mcGlobal.appList.forEach(postClient); }
    
	mcGlobal.appList.forEach(postClient);

    makeChannels();
    
    // the client has to make a global object . 
    // i need an array of 
    
    if (debugLevel[4]) { post("list Length:", mcGlobal.appList.listLength, "\n"); }
    if (debugLevel[1]) { post("                     ---end processNewClientNotification-\n"); }
}

function isInAppLedWindow(_indexOfApp, _columnOfLed, _rowOfLed) {
    var leftEdgeOfWindow = appList[_indexOfApp][5]; // width
    var rightEdgeOfWindow = appList[_indexOfApp][5] + appList[_indexOfApp][6]; // width + columnOffset
    var topEdgeOfWindow = appList[_indexOfApp][7]; // height
    var bottomEdgeOfWindow = appList[_indexOfApp][7] + appList[_indexOfApp][8]; // height + rowOffset
    if ((leftEdgeOfWindow < _columnOfLed < rightEdgeOfWindow) && (topEdgeOfWindow < _rowOfLed < bottomEdgeOfWindow)) {
        return true;
    }
    else { return false; }
}

function processLed(_appName, _appChannel, _keyOne, _keyTwo, _col, _row, _state) {
    if (debugLevel[5]) { post("                     --processLed--", _col, _row, "\n"); }

    _appIndex = findApp([_appName, _appChannel, _keyOne, _keyTwo]);
    
    if(_appIndex > -1) {
        var columnValueAfterOffset = _col + mcGlobal.appList[_appIndex][7];
        var rowValueAfterOffset = _row +  mcGlobal.appList[_appIndex][8];
        outlet(0, columnValueAfterOffset, rowValueAfterOffset, _state);
    }
}

function updateWindowDimensions(_appName, _appChannel, _keyOne, _keyTwo, _width, _height, _colOffset, _rowOffset) {
    // relevant element indices -> 5<width>, 6<heigth>, 7<displayColumnOffset>, 8<displayRowOffset> 
    
    _appIndex = findApp([_appName, _appChannel, _keyOne, _keyTwo]);
    
    if(_appIndex > -1) {
        if (debugLevel[3]) { post("name of app to update:", mcGlobal.appList[_appIndex][0], "\n"); }
        
        if (debugLevel[5]) { post("updating width to:", _width, "\n"); }
        mcGlobal.appList[_appIndex][5] = _width;
        
        if (debugLevel[5]) { post("updating height to:", _height, "\n"); }
        mcGlobal.appList[_appIndex][6] = _height;
        
        if (debugLevel[5]) { post("updating colOffset to:", _colOffset, "\n"); }
        mcGlobal.appList[_appIndex][7] = _colOffset;
        
        if (debugLevel[5]) { post("updating rowOffset to:", _rowOffset, "\n"); }
        mcGlobal.appList[_appIndex][8] = _rowOffset;
    }
    
    outlet(0, "clear");
    messnamed("allClients", "refreshWindow");
}

function acknowledgeClient(element, index, array) {
    if (debugLevel[1]) { post("                     ---acknowledgeClient-\n"); }
    
    var idArray = [element[0], element[2], element[3], element[4] ];
    //post("!!!!!!!!", element[0], element[2], element[3], element[4], "\n");
    messnamed("allClients", "clientAcknowledgement", element[0], element[2], element[3], element[4]);
}

function doesShareName(element, index, array) {
    if (debugLevel[5]) { post("                     ---doesShareName-\n"); }
    
    if (debugLevel[5]) {
		post("name of element:", element[0], "name i am looking for:", this.toString(), "\n");
    	post("are they equal?", (element[0] == this.toString()), "\n");
	}
    return (element[0] == this.toString());
}

function postClient(element, index, array) {
    post("#" + index + ":", element[0], "key1", element[3], "key2", element[4], "channel #", element[2], "width", element[5], "height", element[6], 
    "widthOffset", element[7], "heightOffset", element[8], "\n"); // !! name and channel
    //post("full entry:", element, "\n");
}

function closeSingleChannel(element, index, array) {
    element[1] = null;
}

function makeChannels(_chanNum) {
    if (debugLevel[1]) { post("                     ---makeChannels-\n"); }
    
    if(channelsMade) {
        mcGlobal.appList.forEach(closeSingleChannel);
    }
    
    var listLength = mcGlobal.appList.length;
    for (var g = 0; g < listLength; g++){
        var channelName = mcGlobal.appList[g][0] + mcGlobal.appList[g][2];
        if (debugLevel[4]) { post("channel name is", channelName, "\n"); }
        mcGlobal.appList[g][1] = new Global(channelName);
    }
    if (debugLevel[4]) { post("channelName in router:", channelName, "\n"); }
    channelsMade = true;
}


function removeClient(_appName, _channelNumber, _key1, _key2) {
    if (debugLevel[1]) { post("                     ---removeClient-\n"); }
    
    var appEntry = [_appName, _channelNumber, _key1, _key2]; // !!name, number, key1, key2 --this is all findApp needs.
    if (debugLevel[4]) { post("entry of app to remove", appEntry, "\n"); }
    theApp = findApp(appEntry);
    
    if (debugLevel[3]) { if (theApp != -1) { post("app found!", theApp, "\n"); } }
    else { post("no, really, how did we get here?\n"); }
    
    mcGlobal.appList.splice(theApp, 1);
    
    if (mcGlobal.appList.length > 0) {
        mcGlobal.appList.forEach(acknowledgeClient);
        if (debugLevel[5]) { mcGlobal.appList.forEach(postClient); }
		
        makeChannels();
    }
}

function findApp(array) {
    if (debugLevel[5]) { post("                     ---findApp-\n"); }
    
    if (debugLevel[3]) { post("app array to find:", array[0], array[1], array[2], array[3], "\n"); }
    if (debugLevel[5]) { 
        post("list of current clients\n");
        mcGlobal.appList.forEach(postClient);
    }
    
    var listLength = mcGlobal.appList.length;

    for (var j = 0;j < listLength; j++) {
        if ((mcGlobal.appList[j][0] == array[0]) && (mcGlobal.appList[j][3] == array[2]) && (mcGlobal.appList[j][4] == array[3])) 
        { // !!name number key1 key2
            return j;
        }
    }
    if (debugLevel[5]) { post("how did we get here?\n"); }
    return -1;
}

function release() {
    post("maxMonoConfig released");
    
}

function press(_column, _row, _state) {
    if (debugLevel[1]) { post("                     --press--\n"); }
    
    
//    for (var g = 0; g < mcGlobal.appList.length; g++){
//        
//        if (debugLevel[5]) { post("talking to:", mcGlobal.appList[g][0], "\n"); }
//        
//        mcGlobal.appList[g][1].press(_column, _row, _state);    
//        
//        if (debugLevel[3]) { post("press:", _column, _row, _state, "sent to:", mcGlobal.appList[g][0], mcGlobal.appList[g][2], " \n"); }
//    }
    mcGlobal.appList.forEach(sendPressToWindows, [_column, _row, _state]);
}

function sendPressToWindows(element, index, array) {
    // this = [col, row, state]
    // element -> 0<name> 1<channelObject> 2<channelNumber> 3<key1> 4<key2> 5<width>, 6<heigth>, 7<displayColumnOffset>, 8<displayRowOffset> 
    
    var leftEdgeOfWindow = element[7] - 1; // columnOffset
    var rightEdgeOfWindow = element[5] + element[7]; // width + columnOffset
    var topEdgeOfWindow = element[8] - 1; // rowOffset
    var bottomEdgeOfWindow = element[6] + element[8]; // height + rowOffset
    
    var translatedColumnn = this[0] - element[7];
    var translatedRow = this[1] - element[8];    
    
    if ((leftEdgeOfWindow < this[0]) && (this[0] < rightEdgeOfWindow)){
        if((topEdgeOfWindow < this[1]) && (this[1] < bottomEdgeOfWindow)) {
            if (debugLevel[3]) { post("press:",translatedColumnn, translatedRow, this[2], "sent to:", element[0], element[2], " \n"); }
            element[1].press(translatedColumnn, translatedRow, this[2]);
        }
    }
}

function testChannels(_ar) {
    if (debugLevel[1]) { post("                     ---testChannels-\n"); }
    
    if (debugLevel[3]) { post("list Length:", mcGlobal.appList.listLength, "\n"); }
    
    for (var g = 0; g < mcGlobal.appList.listLength; g++){
        if (debugLevel[3]) { post("talking to:", mcGlobal.appList[g][0], "\n"); }
        mcGlobal.appList[g][1].connection();
    }
}
post("maxMonoConfigRouter Finished loading");
messnamed("allClients", "newRouterAlert");
